<template>
  <component :is="component"
  :input="input"
  :data="inputData"
  :input-id="inputId"
  :director-select="directorSelect"
  :savedParams="savedParams"
  v-if="component" />
</template>


<script>
import SelectInputFilter from './SelectInputFilter.vue';
import CheckCompanyRegistrationStatus from './CheckCompanyRegistrationStatus.vue';

export default {
  name: 'dynamic-link',
  props: {
    savedParams: Object,
    inputData: Object || Array,
    inputId: String,
    input: Function,
    directorSelect: Object,
  },
  data() {
    return {
      component: null,
    };
  },
  computed: {
    loader() {
      if (this.inputId === 'registrationProgress') {
        return () => CheckCompanyRegistrationStatus;
      }
      if (this.inputId === 'companyId') {
        return () => this.component;
      }
      if (this.inputData.type === 'choice') {
        return () => SelectInputFilter;
      }
      return () => this.component;
    },
  },
  mounted() {
    this.component = this.loader();
  },
};

</script>
